var cached_packet_data = null;


var generate_hex_view_for = function (bytes_count, packet_data, place_wlan_frame) {
    const maxColNum = 16;

    var ul = document.getElementById("ti_ul_legend");
    ul.innerHTML = "";
    if (place_wlan_frame !== undefined && place_wlan_frame === true) {

        for (let index = 0; index < wlan_frame.length; index++) {
            const wlan_field = wlan_frame[index];

            let li = document.createElement("li");
            li.setAttribute("style", `display:inline;margin-right:10px;color:${wlan_field.color};`);
            li.innerText = wlan_field.name;

            ul.appendChild(li);
        }
    }

    var thead = document.getElementById("packet_table_header");
    thead.innerHTML = "";
    var tr = document.createElement("tr");
    var the = document.createElement("th");
    the.innerHTML = "Offset[d]";
    tr.appendChild(the);

    for (var i = 0; i < maxColNum; i++) {
        var th = document.createElement("th");
        th.setAttribute("style", "text-align: center;");
        th.innerHTML = zeroPad(i.toString(), 2);

        tr.appendChild(th);
    }

    thead.appendChild(tr);

    var full_lines = Math.floor(bytes_count / maxColNum);
    var single_bytes = bytes_count % maxColNum;

    if (single_bytes > 0) {
        full_lines++;
    }

    var tbody = document.getElementById("packet_table_body");
    tbody.innerHTML = "";
    var data_counter = 0;

    for (var x = 0; x < full_lines; x++) {

        var r = document.createElement("tr");

        var dp = document.createElement("th");
        dp.setAttribute("style", "text-align: center;");
        dp.innerHTML = zeroPad((maxColNum * x).toString(), 5);
        r.appendChild(dp);

        var colNum = maxColNum;
        if ((x === (full_lines - 1)) && single_bytes > 0) {
            colNum = single_bytes;
        }

        for (var y = 0; y < colNum; y++) {
            var d = document.createElement("td");
            var input = document.createElement("input");
            input.setAttribute("type", "text");
            input.setAttribute("packet_index", data_counter);
            input.setAttribute("value", packet_data[data_counter]);

            console.log(data_counter);

            if (place_wlan_frame !== undefined && place_wlan_frame === true) {
                for (let i = 0; i < wlan_frame.length; i++) {
                    const wlan_field = wlan_frame[i];
                    if (wlan_field.start_byte_pos <= data_counter && data_counter <= wlan_field.stop_byte_pos) {
                        input.setAttribute("style", `width:40px;text-align: center;color:#FFFFFF;background:${wlan_field.color};`);
                        break;
                    }
                }
            } else {
                input.setAttribute("style", "width:40px;text-align: center;color:#000000;background:#FFFFFF;");
            }

            d.appendChild(input);

            r.appendChild(d);

            data_counter++;
        }

        tbody.appendChild(r);
    }

};

var get_packet_data = function () {
    var packet_data = [];
    var input_data = document.querySelectorAll("input[packet_index]");

    input_data.forEach(function (input) {
        packet_data.push(input.value);
        // console.log(input.getAttribute("packet_index"));
        // console.log(input.value);
    });

    return packet_data;
};

var updateLengthBack = function (len) {
    var selectedActionText = templateObj.$.ti_widget_droplist_actions.selectedText;
    switch (selectedActionText) {
        case "Send Transceiver":
            templateObj.$.ti_widget_numberbox_st_packet_length.value = len;
            break;

        case "Send UDP":
            templateObj.$.ti_widget_numberbox_su_packet_length.value = len;
            break;

        case "Send TCP":
            templateObj.$.ti_widget_numberbox_tcp_packet_length.value = len;
            break;
    }
};

var loadRawData = function () {
    var textarea = document.getElementById("packet_raw_view");
    var packet_data = textarea.value.trim();
    if (packet_data === "") {
        alert("No data found please set correct data and try again!");
        return;
    }

    packet_data = packet_data.split(" ");
    generate_hex_view_for(packet_data.length, packet_data);

    updateLengthBack(packet_data.length);

};

var getRawData = function () {
    var textarea = document.getElementById("packet_raw_view");
    textarea.value = get_packet_data().join(" ");

    if (packet_data === "") {
        alert("No data found please set correct data and try again!");
        return;
    }
};

var placeWlanFrame = function () {

    let packet_data = get_packet_data();

    if (packet_data.length > 0) {
        generate_hex_view_for(packet_data.length, packet_data, true);
    }
};

var loadAsciiData = function () {
    var textarea = document.getElementById("packet_ascii_view");
    var packet_data = textarea.value;
    if (packet_data === "") {
        alert("No data found please set correct data and try again!");
        return;
    }

    var arr = [];
    for (var n = 0; n < packet_data.length; n++) {
        var hex = Number(packet_data.charCodeAt(n)).toString(16);
        arr.push(hex);
    }

    generate_hex_view_for(arr.length, arr);

    updateLengthBack(arr.length);
};

var getAsciiData = function () {
    var textarea = document.getElementById("packet_ascii_view");
    var packet_data = get_packet_data();

    var str = "";
    for (var n = 0; n < packet_data.length; n++) {
        str += String.fromCharCode(parseInt(packet_data[n], 16));
    }

    textarea.value = str;
};

var save_packet_data_into_array = function (arr, prefix, pLength) {
    var packet_data = Array(pLength).fill('FF');

    if (cached_packet_data && cached_packet_data.length > 0) {
        packet_data = cached_packet_data;

        var data_changed = {
            "name": prefix + "_data_changed",
            "raw_val": true,
            "val": true,
            "size": -1
        };
        arr.push(data_changed);
    }

    packet_data.forEach(function (data, index) {
        var packet_data = {
            "name": prefix + "_packet_data_" + index.toString(),
            "raw_val": data,
            "val": "0x" + data,
            "size": 1
        };
        arr.push(packet_data);
    });
};

var load_packet_data_from_array = function (arr, prefix) {

    if (get_value_by_name(arr, prefix + "_data_changed")) {
        var index = 0;
        var packet_data = [];
        var data = get_value_by_name(arr, prefix + "_packet_data_" + index.toString());
        while (data !== "") {
            packet_data.push(data);
            index++;
            data = get_value_by_name(arr, prefix + "_packet_data_" + index.toString());
        }

        if (index > 0) {
            //            showEditPacket(index, packet_data);
            cached_packet_data = packet_data;
            updateLengthBack(cached_packet_data.length);
        }
    }

};



