var show_hide_rule_editor_placeholder = function (show) {
    templateObj.$.ti_widget_container_rule_editor_placeholder.style.left = rule_editor_placeholder_pos_left;
    templateObj.$.ti_widget_container_rule_editor_placeholder.style.top = rule_editor_placeholder_pos_top;

    templateObj.$.ti_widget_image_arrow_left.visible = true;
    templateObj.$.ti_widget_image_arrow_right.visible = true;
    templateObj.$.ti_widget_label_rule_editor.visible = true;

    if (show) {
        templateObj.$.ti_widget_image_arrow_left.style.opacity = 0.2;
        templateObj.$.ti_widget_image_arrow_right.style.opacity = 0.2;
        templateObj.$.ti_widget_label_rule_editor.style.opacity = 0.3;

        templateObj.$.ti_widget_container_rule_editor_placeholder.visible = true;
    } else {
        templateObj.$.ti_widget_image_arrow_left.style.opacity = 1;
        templateObj.$.ti_widget_image_arrow_right.style.opacity = 1;
        templateObj.$.ti_widget_label_rule_editor.style.opacity = 1;

        templateObj.$.ti_widget_container_rule_editor_placeholder.visible = false;

        if (templateObj.$.ti_widget_button_save_rule.label === ""){
            templateObj.$.ti_widget_button_save_rule.visible = false;
            templateObj.$.ti_widget_button_clear_rule.visible = false;
        } else {
            templateObj.$.ti_widget_button_save_rule.visible = true;
            templateObj.$.ti_widget_button_clear_rule.visible = true;
        }
    }

}

var show_rule_editor = function () {
    show_hide_rule_editor_placeholder(false);
    templateObj.$.ti_widget_container_rule_editor.visible = true;
};


var hide_rule_editor = function () {
    templateObj.$.ti_widget_container_rule_editor.visible = false;
    show_hide_rule_editor_placeholder(true);
};


var clear_form = function () {
    set_all_primary_conditions_container_hidden();
    set_all_sub_conditions_container_hidden();
    set_all_actions_container_hidden();

    templateObj.$.ti_widget_droplist_primary_conditions.selectedIndex = -1;
    templateObj.$.ti_widget_droplist_sub_conditions.selectedIndex = -1;
    templateObj.$.ti_widget_droplist_actions.selectedIndex = -1;

    templateObj.$.ti_widget_button_save_rule.label = "Save";
    templateObj.$.ti_widget_button_save_rule.buttonType = "default"

    templateObj.$.ti_widget_label_edit_mode.visible = false;

    var ta_packet_raw_view = document.getElementById("packet_raw_view");
    ta_packet_raw_view.value = "";
    var ta_packet_ascii_view = document.getElementById("packet_ascii_view");
    ta_packet_ascii_view.value = "";

    cached_packet_data = null;
}


var Clear = function () {
    hide_rule_editor();

    clear_form();

    inEditMode = {
        "status": false,
        "rule_index": -1
    };
};


var onCancel = function () {
    create_rules_list_view();

    Clear();
};


var onSaveRule = function () {
    rule = {};

    // rule.depended_on = -1;
    // rule.depend_on_me_count = 0;

    rule.name = templateObj.$.ti_widget_droplist_primary_conditions.selectedText
        + ' / ' + templateObj.$.ti_widget_droplist_sub_conditions.selectedText
        + ' / ' + templateObj.$.ti_widget_droplist_actions.selectedText;

    rule = getDataForPrimaryCondition(rule);
    if (rule === undefined) {
        return;
    }

    rule = getDataForSubCondition(rule);
    if (rule === undefined) {
        return;
    }

    rule = getDataForAction(rule);
    if (rule === undefined) {
        return;
    }

    if (inEditMode.status === true) {
        rulesList.rules[inEditMode.rule_index] = rule;
    } else {
        rulesList.rules.push(rule);
    }

    create_rules_list_view();

    Clear();
};
