var reorder_rules = function () {
    new_rules_list = [];

    rulesList.rules.forEach(function (rule, rule_index) {
        rule.follow_after = -1;
        rule.follow_on_me_count = 0;

        if (new_rules_list.length === 0 && rule_index === 0) {
            new_rules_list.push(rule)

        } else {
            var rule_primary_condition_name = rule.name.split(" / ")[0];
            var push_into_index = -1;

            new_rules_list.forEach(function (new_rule, new_rule_index) {
                if (push_into_index === -1) {
                    var new_rule_action_name = new_rule.name.split(" / ")[2];
                    var avaliable_primaty_condition = get_available_primary_conditions_for_action(new_rule_action_name);

                    if (avaliable_primaty_condition) {
                        if (rule_primary_condition_name === avaliable_primaty_condition.name) {
                            var prim_cond_val = get_value_by_name(rule.primary_conditions_params, avaliable_primaty_condition.link_field.prim_cond_db);
                            var act_val = get_value_by_name(new_rule.action_params, avaliable_primaty_condition.link_field.act_db);

                            if (prim_cond_val === act_val) {
                                rule.follow_after = new_rule_index;
                                new_rule.follow_on_me_count += 1;
                                push_into_index = new_rule_index + new_rule.follow_on_me_count;
                            }
                        }
                    }
                }
            });

            if (push_into_index !== -1) {
                new_rules_list.splice(push_into_index, 0, rule);
            } else {
                new_rules_list.push(rule)
            }
        }
    });

    console.log(new_rules_list);
    rulesList.rules = new_rules_list.slice();
};

var create_rules_list_view = function () {
    var labels = [];
    templateObj.$.ti_widget_listbox_rules_list.labels = "";

    reorder_rules();

    var outer_index = 0;
    var outer_index_counter = 0;

    rulesList.rules.forEach(function (rule, index) {
        var display_name = null;

        if (rule.follow_after !== -1) {
            outer_index_counter += 1;

            display_name = (outer_index).toString() + "." + (outer_index_counter).toString() + ". " + rule.name;
        } else {
            outer_index += 1;
            outer_index_counter = 0;

            display_name = (outer_index).toString() + ". " + rule.name;
        }

        if (display_name !== null) {
            labels.push(display_name);
        }
    });

    // Disabling Device Type drop down after first added rule in order to prevent from use to change in middle of work
    if (labels.length > 0) {
        templateObj.$.ti_widget_droplist_device_type.disabled = true;
    } else {
        templateObj.$.ti_widget_droplist_device_type.disabled = false;
    }

    templateObj.$.ti_widget_listbox_rules_list.labels = labels.join('|');
    templateObj.$.ti_widget_listbox_rules_list.selectedIndex = -1;
};

var onAddRule = function () {
    var ruleIndex = templateObj.$.ti_widget_listbox_rules_list.selectedIndex;

    if (rulesList.rules.length >= max_rules_number) {
        alert("Max number of rules is 16");
        return;
    }

    if (templateObj.$.ti_widget_droplist_device_type.selectedIndex === -1) {
        alert("Please select device type before selecting action");
        templateObj.$.ti_widget_droplist_actions.selectedIndex = -1;
        return;
    }

    Clear();

    templateObj.$.ti_widget_droplist_primary_conditions.labels = get_list_of_primary_conditions().join('|');
    templateObj.$.ti_widget_droplist_sub_conditions.labels = get_list_of_sub_conditions().join('|');
    templateObj.$.ti_widget_droplist_actions.labels = get_list_of_actions().join('|');

    show_rule_editor();

    console.log(ruleIndex);
    if (ruleIndex !== -1) {
        var selected_rule = rulesList.rules[ruleIndex];
        var action_name = selected_rule.name.split(" / ")[2];
        if (action_name) {
            var avaliable_primaty_condition = get_available_primary_conditions_for_action(action_name);
            if (avaliable_primaty_condition) {
                templateObj.$.ti_widget_droplist_primary_conditions.selectedText = avaliable_primaty_condition.name;
                onPrimaryConditionSelected();

                var prim_cond_elem = document.getElementById(avaliable_primaty_condition.link_field.prim_cond_elem);
                prim_cond_elem.selectedText = get_value_by_name(selected_rule.action_params, avaliable_primaty_condition.link_field.act_db);

                inContinuesMode.status = true;
                inContinuesMode.previous_rule_index = ruleIndex;
            }
        }
    }

    templateObj.$.ti_widget_droplist_device_type.disabled = true;
};

var onEditRule = function () {
    var ruleIndex = templateObj.$.ti_widget_listbox_rules_list.selectedIndex;

    if (rulesList.rules.length <= 0) {
        return;
    }

    if (ruleIndex === -1) {
        alert("Please select rule before edit");
        return;
    }

    var rule = rulesList.rules[ruleIndex];

    Clear();

    templateObj.$.ti_widget_droplist_primary_conditions.labels = get_list_of_primary_conditions().join('|');
    templateObj.$.ti_widget_droplist_sub_conditions.labels = get_list_of_sub_conditions().join('|');
    templateObj.$.ti_widget_droplist_actions.labels = get_list_of_actions().join('|');

    templateObj.$.ti_widget_button_save_rule.label = "Update";
    templateObj.$.ti_widget_button_save_rule.buttonType = "primary"

    templateObj.$.ti_widget_label_edit_mode.label = "In Edit Mode of Rule : " + zeroPad(ruleIndex + 1, 2);
    templateObj.$.ti_widget_label_edit_mode.fontColor = "#CC0000";
    templateObj.$.ti_widget_label_edit_mode.visible = true;

    inEditMode = {
        "status": true,
        "rule_index": ruleIndex
    };

    // show_rule_editor();

    // loadDataForPrimaryCondition(rule);
    // loadDataForSubConditions(rule);
    // loadDataForActions(rule);

    loadUI(rule);
};

async function loadUI(rule) {
    var r = await show_rule_editor()
    var r = await loadDataForPrimaryCondition(rule)
    var r = await loadDataForSubConditions(rule)
    var r = await loadDataForActions(rule)
}

var onDeleteRule = function () {
    var index = templateObj.$.ti_widget_listbox_rules_list.selectedIndex;
    console.log(index);

    if (inEditMode.status === true && inEditMode.rule_index === index) {
        alert("You can't delete this rule because it in edit mode");
    } else {
        if (rulesList.rules.length > 0) {
            rulesList.rules.splice(index, 1);
            create_rules_list_view();
        }
    }
};

var onDeleteAllRules = function () {
    if (inEditMode.status === true) {
        alert("You are in edit mode please update or clear before delete all");
    } else {
        if (rulesList.rules.length > 0) {
            rulesList.rules = [];

            templateObj.$.ti_widget_droplist_device_type.selectedIndex = -1;
            create_rules_list_view();

            Clear();
        }
    }
};

var onMoveRuleUp = function () {
    var index = templateObj.$.ti_widget_listbox_rules_list.selectedIndex;

    if (index !== -1 && (index - 1) >= 0) {
        arraymove(rulesList.rules, index, index - 1);
        create_rules_list_view();
    }

    templateObj.$.ti_widget_listbox_rules_list.selectedIndex = -1;
};

var onMoveRuleDown = function () {
    var index = templateObj.$.ti_widget_listbox_rules_list.selectedIndex;

    if (index !== -1 && (index + 1) <= rulesList.rules.length) {
        arraymove(rulesList.rules, index, index + 1);
        create_rules_list_view();
    }

    templateObj.$.ti_widget_listbox_rules_list.selectedIndex = -1;
};

var onRulesExport = function () {
    if (inEditMode.status === true) {
        alert("You can't export while in edit mode");
        return;
    }

    if (rulesList.rules.length > 0) {

        rulesList.device_type = {
            "raw_val": templateObj.$.ti_widget_droplist_device_type.selectedIndex,
            "val": templateObj.$.ti_widget_droplist_device_type.selectedText
        };

        var blob = new Blob([JSON.stringify(rulesList, null, 2)], { type: 'application/json' });
        saveAs(blob, "nap.json");

    } else {
        alert("No rule found in rules list please save one and try again");
    }
};

var loadJson = function () {
    var input = document.getElementById('myFileLoadDialog');

    if (!input) {
        alert("Um, couldn't find the fileinput element.");
    }
    else if (!input.files) {
        alert("This browser doesn't seem to support the `files` property of file inputs.");
    }
    else if (!input.files[0]) {
        alert("Please select a file before clicking 'Load'");
    }
    else {
        file = input.files[0];
        fr = new FileReader();
        fr.onload = receivedText;
        fr.readAsText(file);
    }

    function receivedText(e) {
        let lines = e.target.result;
        rulesList = JSON.parse(lines);

        console.log(rulesList);

        //clear view
        Clear();
        
        // Update device type
        templateObj.$.ti_widget_droplist_device_type.selectedIndex = rulesList.device_type.raw_val;

        create_rules_list_view();
    }
};

var onRulesImport = function () {
    if (inEditMode.status === true) {
        alert("You can't import while in edit mode");
        return;
    }

    var input = document.getElementById("myFileLoadDialog");
    input.addEventListener("change", loadJson, false);
    input.click();


    // gc.File.browseAndLoad(null, null, function(data,fileInfo,err) {
    //     rulesList = JSON.parse(data);
    //     // console.log(rulesList);
    //     create_rules_list_view();
    // }, myFileLoadDialog);
};

var onGenerateTLV = function () {
    if (inEditMode.status === true) {
        alert("You can't generate tlv while in edit mode");
        return;
    }

    if (rulesList.rules.length > 0) {
        var content = "";

        rulesList.rules.forEach(function (rule) {
            content += getContentForRule(rule);
        });

        content = addTermination(content);

        // var uriContent = "data:application/octet-stream," + encodeURIComponent(content).substr(3);
        var uriContent = "data:application/octet-stream;base64," + btoa(content);
        var link = document.createElement("a");
        link.href = uriContent;
        link.download = (templateObj.$.ti_widget_input_file_name.value || "naptlv.bin");
        link.click();
    } else {
        alert("Please add some rule before save any binary tlv file!")
    }
}

var user_selected = function (index) {
    console.log(index);
}

var onRuleListClick = function (event) {
    // height_per_line = Math.floor(parseInt(templateObj.$.ti_widget_listbox_rules_list.$.listBoxDiv.style.height) / max_rules_number);
    // console.log(height_per_line);
    // console.log(event);

    // calced_index = Math.floor(event.offsetY / height_per_line); 

    Clear();

    if (event.path[0].id === "selectorList") {
        console.log("Select : None");
        templateObj.$.ti_widget_listbox_rules_list.selectedIndex = -1;

    } else {
        var ruleIndex = templateObj.$.ti_widget_listbox_rules_list.selectedIndex
        console.log("Select : ", ruleIndex);
        var rule = rulesList.rules[ruleIndex];

        templateObj.$.ti_widget_droplist_primary_conditions.labels = get_list_of_primary_conditions().join('|');
        templateObj.$.ti_widget_droplist_sub_conditions.labels = get_list_of_sub_conditions().join('|');
        templateObj.$.ti_widget_droplist_actions.labels = get_list_of_actions().join('|');

        templateObj.$.ti_widget_button_save_rule.label = "";
        // templateObj.$.ti_widget_button_save_rule.buttonType = "primary"

        templateObj.$.ti_widget_label_edit_mode.label = "In View Mode of Rule : " + zeroPad(ruleIndex + 1, 2);
        templateObj.$.ti_widget_label_edit_mode.fontColor = "#115566";
        templateObj.$.ti_widget_label_edit_mode.visible = true;

        loadUI(rule);
    }


}

var getAllUsedCounterNumbers = function () {

    counter_list = []

    var increment_counter_action_obj = get_action_obj_by_name("Increment counter");
    var set_counter_action_obj = get_action_obj_by_name("Set counter");

    rulesList.rules.forEach(function (rule, rule_index) {
        if (rule.action_type.val === increment_counter_action_obj.id) {
            rule.action_params.forEach(function (param, param_index) {
                if (param.name === "inc_count_counter_number") {
                    counter_list.push(param.raw_val);
                }
            });
        }

        if (rule.action_type.val === set_counter_action_obj.id) {
            rule.action_params.forEach(function (param, param_index) {
                if (param.name === "set_count_counter_number") {
                    counter_list.push(param.raw_val);
                }
            });
        }
    });

    // console.log(counter_list.join('|'));
    return counter_list.join('|')
}

var getAllUsedTimerNumbers = function () {

    timer_list = []

    var timer_control_action_obj = get_action_obj_by_name("Timer control");

    rulesList.rules.forEach(function (rule, rule_index) {
        if (rule.action_type.val === timer_control_action_obj.id) {
            rule.action_params.forEach(function (param, param_index) {
                if (param.name === "tmr_ctrl_timer_number") {
                    timer_list.push(param.raw_val);
                }
            });
        }
    });

    // console.log(timer_list.join('|'));
    return timer_list.join('|')
}